\\ Copyright 2022, 2023 Kevin Ryde

\\ This file is part of pari-primecount.

\\ pari-primecount is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ pari-primecount is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with pari-primecount.  If not, see <http://www.gnu.org/licenses/>.

default(strictargs,1);
default(recover,0);
primecount_use_program = 0;
default(sopath,"..:/usr/lib:/usr/lib/i386-linux-gnu/");
read("../primecount.gp");


\\-----------------------------------------------------------------------------
\\ no memory leaks

{
  while(1,
        primecount_pi(9999999);
        primecount_get_max_x();
        primecount_nth_prime(99999999);
        primecount_phi(99999,123132);

        primecount_version();
        primecount_get_num_threads();
        primecount_set_num_threads(2);
        );
}

\\-----------------------------------------------------------------------------
\\ simulate bad output from primeocunt program

{
system("
set -x;
mkdir -p /tmp/try-primecount;
echo '#!/bin/sh' >/tmp/try-primecount/primecount;
echo 'echo blah' >>/tmp/try-primecount/primecount;
chmod 755 /tmp/try-primecount/primecount;
PATH=/tmp/try-primecount:$PATH;
export PATH;
which primecount;
primecount;
echo 'read(\"../primecount.gp\"); print(primecount_pi(100))' | gp -f --quiet
");
}
quit

\\-----------------------------------------------------------------------------
\\ "digit_set" local variable

print();
print(primecount_version);
print();
print(primecount_INTERNAL_validate);
quit


\\-----------------------------------------------------------------------------
\\ primecount_pi()

primecount_pi(100)
primecount_pi(0)
quit

\\-----------------------------------------------------------------------------
\\ primecount_nth_prime()

primecount_nth_prime(1)
primecount_nth_prime(2^32)
\\ primecount_nth_prime(0)
primecount_nth_prime(216289611853439384 + 10)
quit

\\-----------------------------------------------------------------------------
\\ primecount_set_num_threads() int overflow

print("set 2");
primecount_set_num_threads(2)
print(primecount_get_num_threads());

print("set 99");
primecount_set_num_threads(99)
print(primecount_get_num_threads());

print("set 2^32");
primecount_set_num_threads(2^32)
print(primecount_get_num_threads());

print("set -100");
primecount_set_num_threads(-100)
print(primecount_get_num_threads());
quit

\\-----------------------------------------------------------------------------
\\ install() error print
{
  my(ret = iferr(install("no_such_func","",,
                         "no_such_library.so"); 0,
                 e, 1));
  print("ret = "ret);
  quit;
}
  

\\-----------------------------------------------------------------------------

install("pariprimecount_version","","primecount_version","./pariprimecount.so");
print("primecount_version ",primecount_version());


install("pariprimecount_get_max_x","","primecount_get_max_x","./pariprimecount.so");
print("primecount_get_max_x ",primecount_get_max_x());

install("pariprimecount_pi","G","primecount_pi","./pariprimecount.so");
foo
primepi(123)
\\ primecount_pi('x)
primecount_pi(123)
primecount_pi(2^40)
primecount_pi(2^63)
quit

\\ int primecount_get_num_threads();
\\ void primecount_set_num_threads(int num_threads);
install("primecount_get_num_threads","i",,"libprimecount.so");
install("primecount_set_num_threads","iI",,"libprimecount.so");
print("primecount_get_num_threads ",primecount_get_num_threads());
print("primecount_set_num_threads ",primecount_set_num_threads(1));
print("primecount_get_num_threads ",primecount_get_num_threads());
print("primecount_set_num_threads ",primecount_set_num_threads(10));
